]> git.treefish.org Git - backmeupscotty.git/commitdiff
formatting; introduced bwlimit
authorAlexander Schmidt <alex@treefish.org>
Tue, 17 Sep 2019 19:20:33 +0000 (21:20 +0200)
committerAlexander Schmidt <alex@treefish.org>
Tue, 17 Sep 2019 19:20:33 +0000 (21:20 +0200)
backmeupscotty
backmeupscotty-example

index ff0f07ffa66104a53932bc3d428a61f0bdf80ee0..3a9abb894d91de8b99a81e4af3eeb34e6f63425b 100644 (file)
@@ -5,6 +5,7 @@ REMOTE_DIR=/tmp/backmeupscotty/test
 ARCHIVE_KEEPNBACKUPS=30
 ARCHIVE_KEEPNDAYS=30
 BACKUP_RUNEVERYNTHDAY=1
+BWLIMIT=500KiB
 
 _ERROR_ENCOUNTERED=0
 
@@ -18,17 +19,17 @@ function scottyline {
 
 function scottyinfo {
     if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
-       scottyline $@
+        scottyline $@
     else
-       scottyline $@ >&2
+           scottyline $@ >&2
     fi
 }
 
 function scottyerror {
     scottyline $@ >&2
     if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
-       _ERROR_ENCOUNTERED=1
-       scottyline "Going into verbose mode after error encounter." >&2
+           _ERROR_ENCOUNTERED=1
+           scottyline "Going into verbose mode after error encounter." >&2
     fi
 }
 
@@ -37,10 +38,10 @@ function ssh255 {
     sshret=$?
 
     if [ $sshret -eq 255 ]; then
-       scottyerror "SSH connection failed!"
-       exit 1
+           scottyerror "SSH connection failed!"
+           exit 1
     else
-       return $sshret
+           return $sshret
     fi
 }
 
@@ -50,30 +51,29 @@ function grepbackups {
 
 function isIncomplete {
     if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
-       return 0
+           return 0
     else
-       return 1
+           return 1
     fi
 }
 
 function isNthDay {
-    if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
+    if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
     then
-       return 0
+           return 0
     else
-       return 1
-    fi 
+           return 1
+    fi
 }
 
 function latestTooOld {
     for oldbackup in $(grepbackups); do
-       tstamp=$(echo $oldbackup | cut -d'-' -f1)
-       
-       if [ $(( $(date +%s) - $tstamp )) -lt \
-           $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
-       then
-           return 1
-       fi
+           tstamp=$(echo $oldbackup | cut -d'-' -f1)
+
+           if [ $(( $(date +%s) - $tstamp )) -lt $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
+           then
+               return 1
+           fi
     done
 
     return 0
@@ -85,13 +85,13 @@ function scottysync {
     scottyinfo "Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp."
 
     if [ ! -d "$SYNC_SRC" ]; then
-       scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
-       return 1
+           scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
+           return 1
     fi
 
     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
-       scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
-       return 1
+           scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
+           return 1
     fi
 
     dir_current=$REMOTE_DIR/current
@@ -99,51 +99,52 @@ function scottysync {
     dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
 
     if [ -z $SYNC_EXC ]; then
-       rsync_exclude=""
+           rsync_exclude=""
     else
-       rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
+           rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
     fi
 
     if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
-       scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
-       ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
+           scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
+           ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
     fi
 
     if isIncomplete; then
-       scottyerror "Continuing old incomplete backup."
+           scottyerror "Continuing old incomplete backup."
     fi
 
     scottyinfo "Starting rsync."
-    rsync -e ssh \
-       -v -aHAX --numeric-ids --delete --delete-excluded \
-       --link-dest=$dir_current \
-       $rsync_exclude \
-       $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
-    
+    rsync -e ssh --bwlimit=$BWLIMIT \
+          -v -aHAX --numeric-ids --delete --delete-excluded \
+          --link-dest=$dir_current \
+          $rsync_exclude \
+          $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
+
     if [ $? -eq 0 ]; then
-       scottyinfo "Timestamping completed backup and linking to current backup."
-       ssh255 $REMOTE_HOST \
-           "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
+           scottyinfo "Timestamping completed backup and linking to current backup."
+           ssh255 $REMOTE_HOST \
+                  "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && \
+               ln -s $(basename $dir_timestamped) $dir_current"
     else
-       scottyerror "Rsync failed."
+           scottyerror "Rsync failed."
     fi
 
     while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
-       oldestbackup=$(grepbackups | head -1)
-       oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
-
-       if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
-           scottyinfo "Removing old backup $oldestbackup."
-           ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
-       else
-           break
-       fi
+           oldestbackup=$(grepbackups | head -1)
+           oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
+
+           if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
+               scottyinfo "Removing old backup $oldestbackup."
+               ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
+           else
+               break
+           fi
     done
 }
 
 function deleteLock {
     if ! rmdir /var/lock/$(basename $0); then
-       scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
+           scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
     fi
 }
 
@@ -153,8 +154,8 @@ function cleanup_abort {
     cleanup ABORT
 
     if [ $(jobs -p) ]; then
-       scottyerror "TERMinating remaining child processes."
-       kill $(jobs -p)
+           scottyerror "TERMinating remaining child processes."
+           kill $(jobs -p)
     fi
 
     deleteLock
@@ -188,29 +189,29 @@ EOF
 
 function backmeupscotty {
     while getopts "qn:h" opt; do
-       case $opt in
-           q)
-               exec > /dev/null
-               ;;
-           n)
-               BACKUP_RUNEVERYNTHDAY=$OPTARG
-               ;;
-           h)
-               printhelp
+           case $opt in
+               q)
+                       exec > /dev/null
+                       ;;
+               n)
+                       BACKUP_RUNEVERYNTHDAY=$OPTARG
+                       ;;
+               h)
+                       printhelp
                 exit 0
                 ;;
-       esac
+           esac
     done
-    
+
     ssh255 $REMOTE_HOST exit
 
     if latestTooOld; then
-       scottyerror "The latest backup is too old."
+           scottyerror "The latest backup is too old."
     elif isNthDay; then
-       scottyinfo "This is the nth day."
+           scottyinfo "This is the nth day."
     else
-       scottyinfo "No backup has to be done. Exiting."
-       exit 0
+           scottyinfo "No backup has to be done. Exiting."
+           exit 0
     fi
 
     scottyinfo "Performing backup."
index d7a1d07cdf0e281ab882d1439e8e6e31d64cf219..15b05b561ade336fc39e8ce9dc3db936c555712b 100755 (executable)
@@ -9,6 +9,7 @@ ARCHIVE_KEEPNDAYS=0
 BACKUP_RUNEVERYNTHDAY=1
 SYNC_SRC="/tmp/scotty/src"
 SYNC_EXC="/gack,/gugu/*"
+BWLIMIT=600KiB
 
 function prepare {
     echo "prepare"